<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.cdd.parser;<a name="line.34"></a>
<FONT color="green">035</FONT>    import java.io.BufferedReader;<a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.File;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.io.FileInputStream;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.io.FileNotFoundException;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.io.IOException;<a name="line.39"></a>
<FONT color="green">040</FONT>    import java.io.InputStream;<a name="line.40"></a>
<FONT color="green">041</FONT>    import java.io.InputStreamReader;<a name="line.41"></a>
<FONT color="green">042</FONT>    import java.io.Reader;<a name="line.42"></a>
<FONT color="green">043</FONT>    import java.util.regex.Matcher;<a name="line.43"></a>
<FONT color="green">044</FONT>    import java.util.regex.Pattern;<a name="line.44"></a>
<FONT color="green">045</FONT>    <a name="line.45"></a>
<FONT color="green">046</FONT>    import ch.javasoft.math.NumberMatrixConverter;<a name="line.46"></a>
<FONT color="green">047</FONT>    <a name="line.47"></a>
<FONT color="green">048</FONT>    /**<a name="line.48"></a>
<FONT color="green">049</FONT>     * The {@code CddParser} parses cdd {@code .ine} or {@code .ext} files, that is,<a name="line.49"></a>
<FONT color="green">050</FONT>     * polyhedra definition files in &lt;b&gt;ine&lt;/b&gt;quality or in &lt;b&gt;ext&lt;/b&gt;reme <a name="line.50"></a>
<FONT color="green">051</FONT>     * ray/vertex form. For exact definitions of the file formats, see<a name="line.51"></a>
<FONT color="green">052</FONT>     * &lt;pre&gt;ftp://ftp.ifor.math.ethz.ch/pub/fukuda/cdd/cddman/node3.html&lt;/pre&gt;<a name="line.52"></a>
<FONT color="green">053</FONT>     * <a name="line.53"></a>
<FONT color="green">054</FONT>     * A sample file looks as follows:<a name="line.54"></a>
<FONT color="green">055</FONT>     * &lt;pre&gt;<a name="line.55"></a>
<FONT color="green">056</FONT>    ////////////////////////////////////<a name="line.56"></a>
<FONT color="green">057</FONT>    * file name: ucube.ine<a name="line.57"></a>
<FONT color="green">058</FONT>    * 3 cube without one "lid"<a name="line.58"></a>
<FONT color="green">059</FONT>    H-representation<a name="line.59"></a>
<FONT color="green">060</FONT>    begin<a name="line.60"></a>
<FONT color="green">061</FONT>        6      4    integer<a name="line.61"></a>
<FONT color="green">062</FONT>      2   -1   0   0<a name="line.62"></a>
<FONT color="green">063</FONT>      2    0  -1   0<a name="line.63"></a>
<FONT color="green">064</FONT>     -1    1   0   0<a name="line.64"></a>
<FONT color="green">065</FONT>     -1    0   1   0<a name="line.65"></a>
<FONT color="green">066</FONT>     -1    0   0   1<a name="line.66"></a>
<FONT color="green">067</FONT>      4   -1  -1   0<a name="line.67"></a>
<FONT color="green">068</FONT>    end<a name="line.68"></a>
<FONT color="green">069</FONT>    incidence<a name="line.69"></a>
<FONT color="green">070</FONT>    adjacency<a name="line.70"></a>
<FONT color="green">071</FONT>    input_adjacency<a name="line.71"></a>
<FONT color="green">072</FONT>    input_incidence<a name="line.72"></a>
<FONT color="green">073</FONT>    ////////////////////////////////////<a name="line.73"></a>
<FONT color="green">074</FONT>    *file name: ccc4.ext<a name="line.74"></a>
<FONT color="green">075</FONT>    *Complete cut cone on 4 vertices<a name="line.75"></a>
<FONT color="green">076</FONT>    *The number of facets is 12.<a name="line.76"></a>
<FONT color="green">077</FONT>    V-representation<a name="line.77"></a>
<FONT color="green">078</FONT>    begin<a name="line.78"></a>
<FONT color="green">079</FONT>        7    7    integer<a name="line.79"></a>
<FONT color="green">080</FONT>     0  1  1  1  0  0  0 <a name="line.80"></a>
<FONT color="green">081</FONT>     0  0  1  1  1  1  0 <a name="line.81"></a>
<FONT color="green">082</FONT>     0  1  0  1  1  0  1 <a name="line.82"></a>
<FONT color="green">083</FONT>     0  1  1  0  0  1  1 <a name="line.83"></a>
<FONT color="green">084</FONT>     0  0  0  1  0  1  1 <a name="line.84"></a>
<FONT color="green">085</FONT>     0  0  1  0  1  0  1 <a name="line.85"></a>
<FONT color="green">086</FONT>     0  1  0  0  1  1  0<a name="line.86"></a>
<FONT color="green">087</FONT>    end<a name="line.87"></a>
<FONT color="green">088</FONT>    hull<a name="line.88"></a>
<FONT color="green">089</FONT>    incidence<a name="line.89"></a>
<FONT color="green">090</FONT>    adjacency<a name="line.90"></a>
<FONT color="green">091</FONT>    ////////////////////////////////////<a name="line.91"></a>
<FONT color="green">092</FONT>     * &lt;/pre&gt;<a name="line.92"></a>
<FONT color="green">093</FONT>     */<a name="line.93"></a>
<FONT color="green">094</FONT>    public class CddParser {<a name="line.94"></a>
<FONT color="green">095</FONT>            private final Object[]                  matrix; <a name="line.95"></a>
<FONT color="green">096</FONT>            private final CddFileType               fileType;<a name="line.96"></a>
<FONT color="green">097</FONT>            private final CddNumberFormat   numberFormat;<a name="line.97"></a>
<FONT color="green">098</FONT>            <a name="line.98"></a>
<FONT color="green">099</FONT>            public CddParser(File file) throws FileNotFoundException, IOException {<a name="line.99"></a>
<FONT color="green">100</FONT>                    this(new FileInputStream(file));<a name="line.100"></a>
<FONT color="green">101</FONT>            }<a name="line.101"></a>
<FONT color="green">102</FONT>            <a name="line.102"></a>
<FONT color="green">103</FONT>            public CddParser(InputStream in) throws IOException {<a name="line.103"></a>
<FONT color="green">104</FONT>                    this(new InputStreamReader(in));<a name="line.104"></a>
<FONT color="green">105</FONT>            }<a name="line.105"></a>
<FONT color="green">106</FONT>    <a name="line.106"></a>
<FONT color="green">107</FONT>            public CddParser(Reader reader) throws IOException {<a name="line.107"></a>
<FONT color="green">108</FONT>                    this(reader instanceof BufferedReader ? (BufferedReader)reader : new BufferedReader(reader));<a name="line.108"></a>
<FONT color="green">109</FONT>            }<a name="line.109"></a>
<FONT color="green">110</FONT>            public CddParser(BufferedReader reader) throws IOException {<a name="line.110"></a>
<FONT color="green">111</FONT>                    CddFileType fileType = null;<a name="line.111"></a>
<FONT color="green">112</FONT>                    String line; int lineNo = 0;<a name="line.112"></a>
<FONT color="green">113</FONT>                    //skip the lines before the preamble<a name="line.113"></a>
<FONT color="green">114</FONT>                    while ((line = reader.readLine()) != null &amp;&amp; (fileType = CddFileType.parsePreamble(line)) == null) {<a name="line.114"></a>
<FONT color="green">115</FONT>                            lineNo++;<a name="line.115"></a>
<FONT color="green">116</FONT>                    }<a name="line.116"></a>
<FONT color="green">117</FONT>                    if (fileType != null) {<a name="line.117"></a>
<FONT color="green">118</FONT>                            //skip preamble line<a name="line.118"></a>
<FONT color="green">119</FONT>                            line = reader.readLine();lineNo++;<a name="line.119"></a>
<FONT color="green">120</FONT>                    }<a name="line.120"></a>
<FONT color="green">121</FONT>                    else {<a name="line.121"></a>
<FONT color="green">122</FONT>                            throw createIOException(CddFileType.Ine.preamble + " or " + CddFileType.Ext.preamble + " expected", lineNo, line);<a name="line.122"></a>
<FONT color="green">123</FONT>                    }<a name="line.123"></a>
<FONT color="green">124</FONT>                    if (line != null &amp;&amp; Keyword.begin.matches(line)) {<a name="line.124"></a>
<FONT color="green">125</FONT>                            line = reader.readLine();lineNo++;<a name="line.125"></a>
<FONT color="green">126</FONT>                    }<a name="line.126"></a>
<FONT color="green">127</FONT>                    else {<a name="line.127"></a>
<FONT color="green">128</FONT>                            throw createIOException(Keyword.begin + " expected", lineNo, line);<a name="line.128"></a>
<FONT color="green">129</FONT>                    }<a name="line.129"></a>
<FONT color="green">130</FONT>                    int m, dims;<a name="line.130"></a>
<FONT color="green">131</FONT>                    CddNumberFormat numberFormat;<a name="line.131"></a>
<FONT color="green">132</FONT>                    //    6      4    integer               <a name="line.132"></a>
<FONT color="green">133</FONT>                    Matcher matcher = Pattern.compile("\\s*([0-9]+)\\s+([0-9]+)\\s+(\\w+)\\s*").matcher(line);<a name="line.133"></a>
<FONT color="green">134</FONT>                    if (!matcher.matches()) {<a name="line.134"></a>
<FONT color="green">135</FONT>                            throw createIOException("preamble syntax error", lineNo, line);<a name="line.135"></a>
<FONT color="green">136</FONT>                    }<a name="line.136"></a>
<FONT color="green">137</FONT>                    m               = Integer.parseInt(matcher.group(1));<a name="line.137"></a>
<FONT color="green">138</FONT>                    dims    = Integer.parseInt(matcher.group(2));<a name="line.138"></a>
<FONT color="green">139</FONT>                    String sFormat = matcher.group(3);//integer, rational, real<a name="line.139"></a>
<FONT color="green">140</FONT>                    try {<a name="line.140"></a>
<FONT color="green">141</FONT>                            numberFormat = CddNumberFormat.valueOf(sFormat);<a name="line.141"></a>
<FONT color="green">142</FONT>                    }<a name="line.142"></a>
<FONT color="green">143</FONT>                    catch (Exception ex) {<a name="line.143"></a>
<FONT color="green">144</FONT>                            throw createIOException("unsupported format in preamble, e=" + ex, lineNo, line);                               <a name="line.144"></a>
<FONT color="green">145</FONT>                    }<a name="line.145"></a>
<FONT color="green">146</FONT>                    <a name="line.146"></a>
<FONT color="green">147</FONT>                    this.matrix = numberFormat.newMatrix(m, dims);<a name="line.147"></a>
<FONT color="green">148</FONT>                    int row = 0;<a name="line.148"></a>
<FONT color="green">149</FONT>                    int col = 0;<a name="line.149"></a>
<FONT color="green">150</FONT>                    while ((line = reader.readLine()) != null &amp;&amp; !Keyword.end.matches(line)) {<a name="line.150"></a>
<FONT color="green">151</FONT>                            lineNo++;<a name="line.151"></a>
<FONT color="green">152</FONT>                            String[] parts = line.trim().split("\\s+");<a name="line.152"></a>
<FONT color="green">153</FONT>                            for (int i = 0; i &lt; parts.length; i++) {<a name="line.153"></a>
<FONT color="green">154</FONT>                                    try {<a name="line.154"></a>
<FONT color="green">155</FONT>                                            numberFormat.parseAndSet(matrix, row, col, parts[i]);<a name="line.155"></a>
<FONT color="green">156</FONT>                                    }<a name="line.156"></a>
<FONT color="green">157</FONT>                                    catch (Exception ex) {<a name="line.157"></a>
<FONT color="green">158</FONT>                                            throw createIOException("cannot parse number value \"" + parts[i] + "\", e=" + ex, lineNo, line);<a name="line.158"></a>
<FONT color="green">159</FONT>                                    }<a name="line.159"></a>
<FONT color="green">160</FONT>                                    col++;<a name="line.160"></a>
<FONT color="green">161</FONT>                                    if (col == dims) {<a name="line.161"></a>
<FONT color="green">162</FONT>                                            col = 0;<a name="line.162"></a>
<FONT color="green">163</FONT>                                            row++;<a name="line.163"></a>
<FONT color="green">164</FONT>                                    }<a name="line.164"></a>
<FONT color="green">165</FONT>                            }<a name="line.165"></a>
<FONT color="green">166</FONT>                    }<a name="line.166"></a>
<FONT color="green">167</FONT>                    if (!Keyword.end.matches(line)) {<a name="line.167"></a>
<FONT color="green">168</FONT>                            throw createIOException("unexpected end of file, " + Keyword.end + " keyword expected", lineNo, line);                  <a name="line.168"></a>
<FONT color="green">169</FONT>                    }<a name="line.169"></a>
<FONT color="green">170</FONT>                    <a name="line.170"></a>
<FONT color="green">171</FONT>                    this.fileType           = fileType;<a name="line.171"></a>
<FONT color="green">172</FONT>                    this.numberFormat       = numberFormat;<a name="line.172"></a>
<FONT color="green">173</FONT>            }<a name="line.173"></a>
<FONT color="green">174</FONT>            <a name="line.174"></a>
<FONT color="green">175</FONT>            private static IOException createIOException(String msg, int lineNo, String line) {<a name="line.175"></a>
<FONT color="green">176</FONT>                    return new IOException("[" + lineNo + "] " + msg + ": " + (line == null ? "&lt;end of file&gt;" : line));<a name="line.176"></a>
<FONT color="green">177</FONT>            }<a name="line.177"></a>
<FONT color="green">178</FONT>            /**<a name="line.178"></a>
<FONT color="green">179</FONT>             * Returns the cdd matrix {@code M} of the polyhedral cone. The cone is <a name="line.179"></a>
<FONT color="green">180</FONT>             * either defined in hyperplane (ine) or extreme ray/vertex (ext) format:<a name="line.180"></a>
<FONT color="green">181</FONT>             * &lt;ul&gt;<a name="line.181"></a>
<FONT color="green">182</FONT>             *      &lt;li&gt;ine: &lt;tt&gt;P = { b - Ax &amp;ge; 0} = { Ax &amp;leq; b }, M=[b -A]&lt;/tt&gt;&lt;/li&gt;<a name="line.182"></a>
<FONT color="green">183</FONT>             *      &lt;li&gt;ext: &lt;tt&gt;P = conv(v) + nonneg(r), M=[ v ; r ], v(*,0)=1, r(*,0)=0&lt;/tt&gt;&lt;/li&gt;<a name="line.183"></a>
<FONT color="green">184</FONT>             * &lt;/ul&gt;<a name="line.184"></a>
<FONT color="green">185</FONT>             */<a name="line.185"></a>
<FONT color="green">186</FONT>            public Object[] getMatrix() {<a name="line.186"></a>
<FONT color="green">187</FONT>                    return matrix;<a name="line.187"></a>
<FONT color="green">188</FONT>            }<a name="line.188"></a>
<FONT color="green">189</FONT>            /**<a name="line.189"></a>
<FONT color="green">190</FONT>             * Casts the matrix into an array of the specified class and returns it. The <a name="line.190"></a>
<FONT color="green">191</FONT>             * returned matrix is the internally kept matrix instance. Consider using <a name="line.191"></a>
<FONT color="green">192</FONT>             * {@link #getMatrixConverted(NumberMatrixConverter)} instead.<a name="line.192"></a>
<FONT color="green">193</FONT>             * &lt;p&gt;<a name="line.193"></a>
<FONT color="green">194</FONT>             * The polyhedral cone is either defined in hyperplane (ine) or extreme <a name="line.194"></a>
<FONT color="green">195</FONT>             * ray/vertex (ext) format. The returned matrix {@code M} defines a cone as<a name="line.195"></a>
<FONT color="green">196</FONT>             * follows:<a name="line.196"></a>
<FONT color="green">197</FONT>             * &lt;ul&gt;<a name="line.197"></a>
<FONT color="green">198</FONT>             *      &lt;li&gt;ine: &lt;tt&gt;P = { b - Ax &amp;ge; 0} = { Ax &amp;leq; b }, M=[b -A]&lt;/tt&gt;&lt;/li&gt;<a name="line.198"></a>
<FONT color="green">199</FONT>             *      &lt;li&gt;ext: &lt;tt&gt;P = conv(v) + nonneg(r), M=[ v ; r ], v(*,0)=1, r(*,0)=0&lt;/tt&gt;&lt;/li&gt;<a name="line.199"></a>
<FONT color="green">200</FONT>             * &lt;/ul&gt;<a name="line.200"></a>
<FONT color="green">201</FONT>             * <a name="line.201"></a>
<FONT color="green">202</FONT>             * @param       arrayClass      the class of the array into which the matrix is cast <a name="line.202"></a>
<FONT color="green">203</FONT>             * @return the matrix {@code M} as described above<a name="line.203"></a>
<FONT color="green">204</FONT>             * @throws ClassCastException   if the matrix is not an array instance of <a name="line.204"></a>
<FONT color="green">205</FONT>             *                                                              the specified class<a name="line.205"></a>
<FONT color="green">206</FONT>             *  <a name="line.206"></a>
<FONT color="green">207</FONT>             * @see #getMatrix()<a name="line.207"></a>
<FONT color="green">208</FONT>             * @see #getMatrixConverted(NumberMatrixConverter)<a name="line.208"></a>
<FONT color="green">209</FONT>             */<a name="line.209"></a>
<FONT color="green">210</FONT>            public &lt;A&gt; A[] getMatrixCast(Class&lt;A&gt; arrayClass) throws ClassCastException {<a name="line.210"></a>
<FONT color="green">211</FONT>                    return CddNumberFormat.castMatrix(arrayClass, matrix);<a name="line.211"></a>
<FONT color="green">212</FONT>            }<a name="line.212"></a>
<FONT color="green">213</FONT>            /**<a name="line.213"></a>
<FONT color="green">214</FONT>             * Converts the matrix using the specified converter and returns it. The <a name="line.214"></a>
<FONT color="green">215</FONT>             * returned matrix is always a new instance. Consider using <a name="line.215"></a>
<FONT color="green">216</FONT>             * {@link #getMatrixCast(Class)} instead.<a name="line.216"></a>
<FONT color="green">217</FONT>             * &lt;p&gt;<a name="line.217"></a>
<FONT color="green">218</FONT>             * The polyhedral cone is either defined in hyperplane (ine) or extreme <a name="line.218"></a>
<FONT color="green">219</FONT>             * ray/vertex (ext) format. The returned matrix {@code M} defines a cone as<a name="line.219"></a>
<FONT color="green">220</FONT>             * follows:<a name="line.220"></a>
<FONT color="green">221</FONT>             * &lt;ul&gt;<a name="line.221"></a>
<FONT color="green">222</FONT>             *      &lt;li&gt;ine: &lt;tt&gt;P = { b - Ax &amp;ge; 0} = { Ax &amp;leq; b }, M=[b -A]&lt;/tt&gt;&lt;/li&gt;<a name="line.222"></a>
<FONT color="green">223</FONT>             *      &lt;li&gt;ext: &lt;tt&gt;P = conv(v) + nonneg(r), M=[ v ; r ], v(*,0)=1, r(*,0)=0&lt;/tt&gt;&lt;/li&gt;<a name="line.223"></a>
<FONT color="green">224</FONT>             * &lt;/ul&gt;<a name="line.224"></a>
<FONT color="green">225</FONT>             * <a name="line.225"></a>
<FONT color="green">226</FONT>             * @param       converter       the converter used to create the matrix and to <a name="line.226"></a>
<FONT color="green">227</FONT>             *                                              convert the values into the desired format<a name="line.227"></a>
<FONT color="green">228</FONT>             * @return the matrix {@code M} as described above<a name="line.228"></a>
<FONT color="green">229</FONT>             *  <a name="line.229"></a>
<FONT color="green">230</FONT>             * @see #getMatrix()<a name="line.230"></a>
<FONT color="green">231</FONT>             * @see #getMatrixCast(Class)<a name="line.231"></a>
<FONT color="green">232</FONT>             */<a name="line.232"></a>
<FONT color="green">233</FONT>            public &lt;A&gt; A[] getMatrixConverted(NumberMatrixConverter&lt;A&gt; converter) throws ClassCastException {<a name="line.233"></a>
<FONT color="green">234</FONT>                    final int rows = matrix.length;<a name="line.234"></a>
<FONT color="green">235</FONT>                    final int cols = numberFormat.getColumnCount(matrix);<a name="line.235"></a>
<FONT color="green">236</FONT>                    final A[] dst = converter.newMatrix(rows, cols);<a name="line.236"></a>
<FONT color="green">237</FONT>                    for (int r = 0; r &lt; rows; r++) {<a name="line.237"></a>
<FONT color="green">238</FONT>                            for (int c = 0; c &lt; cols; c++) {<a name="line.238"></a>
<FONT color="green">239</FONT>                                    final Number val = numberFormat.getNumber(matrix, r, c);<a name="line.239"></a>
<FONT color="green">240</FONT>                                    converter.copy(val, dst, r, c);<a name="line.240"></a>
<FONT color="green">241</FONT>                            }<a name="line.241"></a>
<FONT color="green">242</FONT>                    }<a name="line.242"></a>
<FONT color="green">243</FONT>                    return dst;<a name="line.243"></a>
<FONT color="green">244</FONT>            }<a name="line.244"></a>
<FONT color="green">245</FONT>            public CddFileType getFileType() {<a name="line.245"></a>
<FONT color="green">246</FONT>                    return fileType;<a name="line.246"></a>
<FONT color="green">247</FONT>            }<a name="line.247"></a>
<FONT color="green">248</FONT>            public CddNumberFormat getNumberFormat() {<a name="line.248"></a>
<FONT color="green">249</FONT>                    return numberFormat;<a name="line.249"></a>
<FONT color="green">250</FONT>            }<a name="line.250"></a>
<FONT color="green">251</FONT>            <a name="line.251"></a>
<FONT color="green">252</FONT>            @Override<a name="line.252"></a>
<FONT color="green">253</FONT>            public String toString() {<a name="line.253"></a>
<FONT color="green">254</FONT>                    final int rows = matrix.length;<a name="line.254"></a>
<FONT color="green">255</FONT>                    final int cols = numberFormat.getColumnCount(matrix);<a name="line.255"></a>
<FONT color="green">256</FONT>                    final StringBuilder sb = new StringBuilder();<a name="line.256"></a>
<FONT color="green">257</FONT>                    sb.append("cdd data, P = { ");<a name="line.257"></a>
<FONT color="green">258</FONT>                    sb.append(fileType).append(":");<a name="line.258"></a>
<FONT color="green">259</FONT>                    sb.append(rows).append('x').append(cols);<a name="line.259"></a>
<FONT color="green">260</FONT>                    sb.append(" (").append(numberFormat).append(")");<a name="line.260"></a>
<FONT color="green">261</FONT>                    sb.append(" }");<a name="line.261"></a>
<FONT color="green">262</FONT>                    return sb.toString();<a name="line.262"></a>
<FONT color="green">263</FONT>            }<a name="line.263"></a>
<FONT color="green">264</FONT>            <a name="line.264"></a>
<FONT color="green">265</FONT>            private enum Keyword {<a name="line.265"></a>
<FONT color="green">266</FONT>                    begin, end;<a name="line.266"></a>
<FONT color="green">267</FONT>                    /**<a name="line.267"></a>
<FONT color="green">268</FONT>                     * Returns true if the line matches this keyword. Whitespace at the end <a name="line.268"></a>
<FONT color="green">269</FONT>                     * of the line is ignored.<a name="line.269"></a>
<FONT color="green">270</FONT>                     */<a name="line.270"></a>
<FONT color="green">271</FONT>                    public boolean matches(String line) {<a name="line.271"></a>
<FONT color="green">272</FONT>                            if (line == null) return false;<a name="line.272"></a>
<FONT color="green">273</FONT>                            if (line.startsWith(name())) {<a name="line.273"></a>
<FONT color="green">274</FONT>                                    if (line.substring(name().length()).trim().length() == 0) {<a name="line.274"></a>
<FONT color="green">275</FONT>                                            return true;<a name="line.275"></a>
<FONT color="green">276</FONT>                                    }<a name="line.276"></a>
<FONT color="green">277</FONT>                            }<a name="line.277"></a>
<FONT color="green">278</FONT>                            return false;<a name="line.278"></a>
<FONT color="green">279</FONT>                    }<a name="line.279"></a>
<FONT color="green">280</FONT>            }<a name="line.280"></a>
<FONT color="green">281</FONT>            <a name="line.281"></a>
<FONT color="green">282</FONT>    }<a name="line.282"></a>




























































</PRE>
</BODY>
</HTML>
